/******************************************************************************/
/****         Generated by IBExpert 2006.10.14 10.11.2006 16:15:56         ****/
/******************************************************************************/

SET SQL DIALECT 3;

SET NAMES ISO8859_1;

SET CLIENTLIB 'C:\Program Files\Firebird\Firebird_2_0\bin\fbclient.dll';



/******************************************************************************/
/****                               Domains                                ****/
/******************************************************************************/

CREATE DOMAIN "DOM_Boolean" AS
SMALLINT
DEFAULT 0
CHECK ((VALUE BETWEEN 0 AND 1));

CREATE DOMAIN "DOM_BooleanTrue" AS
SMALLINT
DEFAULT 1
CHECK ((VALUE BETWEEN 0 AND 1));

CREATE DOMAIN "DOM_CNFString" AS
VARCHAR(10000);

CREATE DOMAIN "DOM_CNFZahl" AS
BIGINT;

CREATE DOMAIN "DOM_Description" AS
VARCHAR(2000)
COLLATE DE_DE;

CREATE DOMAIN "DOM_Key" AS
BIGINT
DEFAULT 0
NOT NULL;

CREATE DOMAIN "DOM_LoginName" AS
VARCHAR(20);

CREATE DOMAIN "DOM_ModDate" AS
TIMESTAMP
DEFAULT current_timestamp;

CREATE DOMAIN "DOM_ModPerson" AS
VARCHAR(18)
DEFAULT current_user;

CREATE DOMAIN "DOM_Name" AS
VARCHAR(80);

CREATE DOMAIN "DOM_Short4" AS
CHAR(4)
COLLATE DE_DE;

CREATE DOMAIN "DOM_Word" AS
VARCHAR(80);



/******************************************************************************/
/****                              Generators                              ****/
/******************************************************************************/

CREATE GENERATOR GEN_CNF;
SET GENERATOR GEN_CNF TO 0;

CREATE GENERATOR GEN_CONFTYP;
SET GENERATOR GEN_CONFTYP TO 1;



/******************************************************************************/
/****                              Exceptions                              ****/
/******************************************************************************/

CREATE EXCEPTION DS0 'don''t touch record with id 0';

CREATE EXCEPTION PARAMINVALID 'Input invalid';



SET TERM ^ ; 



/******************************************************************************/
/****                          Stored Procedures                           ****/
/******************************************************************************/

CREATE PROCEDURE "PROC_CNFAddValue" (
    "User" VARCHAR(10),
    "Name" VARCHAR(80),
    "ValueStr" VARCHAR(10000),
    "ValueInt" BIGINT,
    "Description" VARCHAR(2000))
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE "PROC_CNFGetInteger" (
    "inName" VARCHAR(80))
RETURNS (
    "Name" VARCHAR(80),
    "Value" BIGINT,
    "Global" SMALLINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE "PROC_CNFGetString" (
    "inName" VARCHAR(80))
RETURNS (
    "Name" VARCHAR(80),
    "Value" VARCHAR(10000),
    "Global" SMALLINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE "PROC_CNFSetInteger" (
    "Name" VARCHAR(80),
    "Value" BIGINT)
AS
BEGIN
  EXIT;
END^


CREATE PROCEDURE "PROC_CNFSetString" (
    "Name" VARCHAR(80),
    "Value" VARCHAR(10000))
AS
BEGIN
  EXIT;
END^



SET TERM ; ^


/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE CNF (
    "Id"                "DOM_Key",
    "User"              "DOM_LoginName" DEFAULT '<Global>',
    "Name"              "DOM_Name",
    "ValueStr"          "DOM_CNFString",
    "ValueInt"          "DOM_CNFZahl",
    "Description"       "DOM_Description" COLLATE DE_DE,
    "RefTyp"            "DOM_Key",
    "Public"            "DOM_BooleanTrue",
    "CreatedAt"         "DOM_ModDate",
    "CreatedFrom"       "DOM_ModPerson",
    "LastModifiedAt"    "DOM_ModDate",
    "LastModifiedFrom"  "DOM_ModPerson"
);

CREATE TABLE CONFTYP (
    "Id"                "DOM_Key",
    "Name"              "DOM_Name",
    "Public"            "DOM_BooleanTrue",
    "CreatedAt"         "DOM_ModDate",
    "CreatedFrom"       "DOM_ModPerson",
    "LastModifiedAt"    "DOM_ModDate",
    "LastModifiedFrom"  "DOM_ModPerson"
);

INSERT INTO CONFTYP ("Id", "Name", "Public", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (0, 'unstructured', 1, timestamp '2006-11-10 15:29:36', 'SYSDBA', timestamp '2006-11-10 15:29:57', 'SYSDBA');

COMMIT WORK;

INSERT INTO CNF ("Id", "User", "Name", "ValueStr", "ValueInt", "Description", "RefTyp", "Public", "CreatedAt", "CreatedFrom", "LastModifiedAt", "LastModifiedFrom") VALUES (0, '<GLOBAL>', 'default', '', 0, NULL, 0, 0, timestamp '2006-11-10 15:32:17', 'SYSDBA', timestamp '2006-11-10 15:32:17', 'SYSDBA');

COMMIT WORK;



/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE CNF ADD CONSTRAINT PK_CNF PRIMARY KEY ("Id");
ALTER TABLE CONFTYP ADD CONSTRAINT PK_CONFTYP PRIMARY KEY ("Id");


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE CNF ADD CONSTRAINT FK_CNF_REFTYP FOREIGN KEY ("RefTyp") REFERENCES CONFTYP ("Id");


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: CNF_BD0 */
CREATE TRIGGER CNF_BD0 FOR CNF
ACTIVE BEFORE UPDATE OR DELETE POSITION 0
AS
begin
  if (old."Id" = 0) then
    EXCEPTION DS0;
end
^

/* Trigger: CNF_BI0 */
CREATE TRIGGER CNF_BI0 FOR CNF
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_CNF,1);

/* Setze Last* Felder */
  NEW."LastModifiedAt" = current_timestamp;
  NEW."LastModifiedFrom" = current_user;

  if (inserting) then begin
    NEW."CreatedAt" = current_timestamp;
    NEW."CreatedFrom" = current_user;
  end

  if (updating) then begin
    NEW."CreatedAt" = OLD."CreatedAt";
    NEW."CreatedFrom" = OLD."CreatedFrom";
  end
END
^

/* Trigger: CONFTYP_BI0 */
CREATE TRIGGER CONFTYP_BI0 FOR CONFTYP
ACTIVE BEFORE INSERT OR UPDATE POSITION 0
AS
BEGIN
  IF ((NEW."Id" IS NULL) OR (NEW."Id" <= 0)) THEN
    NEW."Id" = GEN_ID(GEN_CONFTYP,1);

/* Setze Last* Felder */
  NEW."LastModifiedAt" = current_timestamp;
  NEW."LastModifiedFrom" = current_user;

  if (inserting) then begin
    NEW."CreatedAt" = current_timestamp;
    NEW."CreatedFrom" = current_user;
  end

  if (updating) then begin
    NEW."CreatedAt" = OLD."CreatedAt";
    NEW."CreatedFrom" = OLD."CreatedFrom";
  end
END
^

/* Trigger: CONFTYP_BUD0 */
CREATE TRIGGER CONFTYP_BUD0 FOR CONFTYP
ACTIVE BEFORE UPDATE OR DELETE POSITION 0
AS
begin
  if (old."Id" = 0) then
    EXCEPTION DS0;
end
^

SET TERM ; ^



/******************************************************************************/
/****                          Stored Procedures                           ****/
/******************************************************************************/


SET TERM ^ ;

ALTER PROCEDURE "PROC_CNFAddValue" (
    "User" VARCHAR(10),
    "Name" VARCHAR(80),
    "ValueStr" VARCHAR(10000),
    "ValueInt" BIGINT,
    "Description" VARCHAR(2000))
AS
DECLARE VARIABLE "Id" BIGINT;
begin
-- copy description from global param
  IF ("Description" = '<inherit>') then
    SELECT "Description" FROM CNF WHERE "Name" = :"Name"
    AND "User" = '<GLOBAL>' INTO :"Description";

  -- check parameter
  IF (("User" IS NULL) OR ("User" = '')) THEN
    exception PARAMINVALID 'User must have a value';

  IF (("Name" IS NULL) OR ("Name" = '')) THEN
    exception PARAMINVALID 'Name must have a value';

  IF (("ValueStr" IS NULL) AND ("ValueInt" IS NULL)) THEN
    exception PARAMINVALID 'Either ValueStr or ValueInt must have a value';

  IF ("ValueStr" IS NULL) THEN
    "ValueStr" = "ValueInt";


-- get id of old param if any
  "Id" = NULL;
  SELECT "Id" FROM CNF WHERE "Name" = :"Name"
    AND "User" = :"User" INTO :"Id";

  IF ("Id" IS NULL) then
    INSERT INTO CNF("User","Name","ValueStr","ValueInt","Description")
      VALUES (:"User",:"Name",:"ValueStr",:"ValueInt",:"Description");
  ELSE
    UPDATE CNF SET "ValueStr" = :"ValueStr", "ValueInt" = :"ValueInt",
      "Description" = :"Description"
      WHERE "Id" = :"Id";

-- set global value
  "Id" = NULL;
  SELECT "Id" FROM CNF WHERE "Name" = :"Name"
    AND "User" = '<GLOBAL>' INTO :"Id";

  IF ("Id" IS NULL) then
    INSERT INTO CNF("User","Name","ValueStr","ValueInt","Description")
      VALUES ('<GLOBAL>',:"Name",:"ValueStr",:"ValueInt",:"Description");
  ELSE
    UPDATE CNF SET "ValueStr" = :"ValueStr", "ValueInt" = :"ValueInt",
      "Description" = :"Description"
      WHERE "Id" = :"Id";
end
^

ALTER PROCEDURE "PROC_CNFGetInteger" (
    "inName" VARCHAR(80))
RETURNS (
    "Name" VARCHAR(80),
    "Value" BIGINT,
    "Global" SMALLINT)
AS
begin
  -- check parameter
  if (:"inName" = '') then
    EXCEPTION PARAMINVALID 'Name invalid';


  IF ("inName" IS NULL) THEN BEGIN
  -- read all
    FOR SELECT distinct "Name" FROM CNF WHERE ("User" = USER) or
      ("User" = '<GLOBAL>') into :"Name" DO BEGIN
      SELECT "Value","Global" FROM "PROC_CNFGetInteger"(:"Name")
      INTO :"Value",:"Global";
      suspend;
    END
  END ELSE BEGIN
    -- read setting for user
    SELECT "ValueInt" FROM CNF
    WHERE "Name" = :"inName" AND "User" = USER
    INTO :"Value";

    "Name" = "inName";

    IF ("Value" IS NULL) THEN BEGIN
    -- read setting for global
      SELECT "ValueInt" FROM CNF
      WHERE "Name" = :"Name" AND "User" = '<GLOBAL>'
      INTO :"Value";
      "Global" = 1;  -- indicate global setting

      -- return number, also if nothing found!
      if ("Value" IS NULL) then BEGIN
        "Global" = -1;
        "Value" = 0;
      END
    END ELSE
      "Global" = 0;

    suspend;
  end
end
^

ALTER PROCEDURE "PROC_CNFGetString" (
    "inName" VARCHAR(80))
RETURNS (
    "Name" VARCHAR(80),
    "Value" VARCHAR(10000),
    "Global" SMALLINT)
AS
begin
  -- check parameter
  if ((:"inName" = '')) then
    EXCEPTION PARAMINVALID 'Name invalid';

  IF ("inName" IS NULL) THEN BEGIN
  -- read all
    FOR SELECT distinct "Name" FROM CNF WHERE ("User" = USER) or
      ("User" = '<GLOBAL>') into :"Name" DO BEGIN
      SELECT "Value","Global" FROM "PROC_CNFGetString"(:"Name")
      INTO :"Value",:"Global";
      suspend;
    END
  END ELSE BEGIN
    -- read setting for user
    SELECT "ValueStr" FROM CNF
    WHERE "Name" = :"inName" AND "User" = USER
    INTO :"Value";

    "Name" = "inName";

    IF ("Value" IS NULL) THEN BEGIN
      SELECT "ValueStr" FROM CNF
      WHERE "Name" = :"Name" AND "User" = '<GLOBAL>'
      INTO :"Value";
      "Global" = 1;

    -- return empty string, if nothing found
      if ("Value" IS NULL) then BEGIN
        "Global" = -1;
        "Value" = '';
      END
    END ELSE
      "Global" = 0;

    suspend;
  end
end
^

ALTER PROCEDURE "PROC_CNFSetInteger" (
    "Name" VARCHAR(80),
    "Value" BIGINT)
AS
begin
  -- check parameter
  if ((:"Name" IS NULL) OR (:"Name" = '')) then
    EXCEPTION PARAMINVALID 'Name invalid';

  -- Delete!
  if (:"Value" IS NULL) THEN BEGIN
      DELETE FROM CNF WHERE "Name" = :"Name"
        and "User" = USER;
  end else begin
  -- Change
      UPDATE CNF SET "ValueInt" = :"Value"
        WHERE "Name" = :"Name" AND "User" = USER;

    if (ROW_COUNT = 0) then
      EXECUTE PROCEDURE "PROC_CNFAddValue"(User,:"Name",null,:"Value", '<inherit>');
  end
  suspend;
end
^

ALTER PROCEDURE "PROC_CNFSetString" (
    "Name" VARCHAR(80),
    "Value" VARCHAR(10000))
AS
begin
  -- check parameter
  if ((:"Name" IS NULL) OR (:"Name" = '')) then
    EXCEPTION PARAMINVALID 'Name invalid';

  -- delete
  if (:"Value" IS NULL) THEN BEGIN
      DELETE FROM CNF WHERE "Name" = :"Name"
        and "User" = USER ;
  end else begin
  -- change
      UPDATE CNF SET "ValueStr" = :"Value"
      WHERE "Name" = :"Name" AND "User" = USER;
    if (ROW_COUNT = 0) then
      EXECUTE PROCEDURE "PROC_CNFAddValue"(User,:"Name",:"Value",null, '<inherit>');
  end

  suspend;
end
^


SET TERM ; ^


/******************************************************************************/
/****                             Descriptions                             ****/
/******************************************************************************/

UPDATE RDB$PROCEDURES
SET RDB$DESCRIPTION = 'adds new config settings'
WHERE (RDB$PROCEDURE_NAME = 'PROC_CNFAddValue');

COMMIT WORK;



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of triggers */
GRANT UPDATE, REFERENCES ON CNF TO TRIGGER CNF_BD0;
GRANT UPDATE, REFERENCES ON CNF TO TRIGGER CNF_BI0;
GRANT UPDATE, REFERENCES ON CONFTYP TO TRIGGER CONFTYP_BI0;
GRANT UPDATE, REFERENCES ON CONFTYP TO TRIGGER CONFTYP_BUD0;

/* Privileges of procedures */
GRANT SELECT, INSERT, UPDATE ON CNF TO PROCEDURE "PROC_CNFAddValue";
GRANT SELECT ON CNF TO PROCEDURE "PROC_CNFGetInteger";
GRANT EXECUTE ON PROCEDURE "PROC_CNFGetInteger" TO PROCEDURE "PROC_CNFGetInteger";
GRANT SELECT ON CNF TO PROCEDURE "PROC_CNFGetString";
GRANT EXECUTE ON PROCEDURE "PROC_CNFGetString" TO PROCEDURE "PROC_CNFGetString";
GRANT SELECT, UPDATE, DELETE ON CNF TO PROCEDURE "PROC_CNFSetInteger";
GRANT EXECUTE ON PROCEDURE "PROC_CNFAddValue" TO PROCEDURE "PROC_CNFSetInteger";
GRANT SELECT, UPDATE, DELETE ON CNF TO PROCEDURE "PROC_CNFSetString";
GRANT EXECUTE ON PROCEDURE "PROC_CNFAddValue" TO PROCEDURE "PROC_CNFSetString";
